(in-package  :custom)
(use-package :oli)

;;----------------------------------------------------------------------------------------------*
;; Vorgaben setzen:                     ;; Moeglicher Vorgabewerte:
;;----------------------------------------------------------------------------------------------*
(setf sk-farbe "RED")                   ;; "BLACK" "WHITE" "RED" "GREEN" "BLUE" "YELLOW" 
                                        ;; "CYAN" "MAGENTA"
(setf sk-linientyp "CENTER_DASH_DASH")  ;; "SOLID" "DOTTED" "DASHED" "LONG_DASHED" "DOT_CENTER"
                                        ;; "DASH_CENTER" "CENTER_DASH_DASH" "PHANTOM"
;;----------------------------------------------------------------------------------------------*

;;----------------------------------------------------------------------------------------------*
;; EVENT zum Umfaerben der Behaelterobjekte nach dem Aktualisieren der Zeichnung
;;----------------------------------------------------------------------------------------------*
;; Deaktivieren
(oli::sd-put-buffer "(oli::sd-unsubscribe-event 'EVENT::DOCU-POST-UPDATE-ALL-EVENT 'am-behaelter-umfaerben)")
;; Aktivieren
(oli::sd-put-buffer "(oli::sd-subscribe-event   'EVENT::DOCU-POST-UPDATE-ALL-EVENT 'am-behaelter-umfaerben)")
;;----------------------------------------------------------------------------------------------*

#|
;;----------------------------------------------------------------------------------------------*
;; Hinweis zur Deaktivierung:
;;----------------------------------------------------------------------------------------------*
Mit manueller Eingabe von:
(oli::sd-put-buffer "(oli::sd-unsubscribe-event 'EVENT::DOCU-POST-UPDATE-ALL-EVENT 'am-behaelter-umfaerben)")
in die Befehlszeile kann man die Umfaerbung wieder deaktivieren !!
;;----------------------------------------------------------------------------------------------*
|#

(sd-defdialog 'am-behaelter-umfaerben
  :toolbox-button nil
  :dialog-control :sequential
  :local-functions
  '((objektliste-erstellen ()
      (let (object)
        (progn
          (setf behaelterobjekte nil)
          (setf behaelterobjekte
            (sd-call-cmds
              (get_selection
                :focus_type *sd-part-seltype*
                :check_function #'(lambda (object)
                                    (if (sd-inq-parent-obj object)
                                      (if (sd-inq-container-p (sd-inq-parent-obj object))
                                        :ok
                                        :filter
                                      )
                                      :filter
                                    )
                                  )
                :select :recursive :all_at_top
              )
              :failure (sd-display-error (format nil "~a => Beim Schreiben der Liste: behaelterobjekte" (sd-inq-error-obj :message)))
            )
          )
        )
      )
    )
    (ansichtsliste-erstellen ()
      (let ()
        (progn
          (setf ansichten nil)
          (setf ansichten
            (sd-call-cmds
              (get_selection
                :focus_type *sd-anno-view-seltype*
                :select :by_drawing_docu_rest
              )
              :failure (sd-display-error (format nil "~a => Beim Schreiben der Liste: ansichten" (sd-inq-error-obj :message)))
            )
          )
        )
      )
    )
    (teile-umfaerben ()
      (let ()
        (progn
          (dolist (ansicht ansichten)
            (progn
              (dolist (behaelterobjekt behaelterobjekte)
                (progn
                  (dc4-anno-teile-umfaerben-dialog
                    :teil_bgr behaelterobjekte
                    :ansicht ansicht
                    :farbe sk-farbe                
                    :linart sk-linientyp
                  )
                )
              )
              (sd-execute-annotator-command :cmd "REDRAW")
            )
          )
        )
      )
    )
  )
  :ok-action
  '(progn
     (objektliste-erstellen)
     (ansichtsliste-erstellen)
     (if (and behaelterobjekte
              ansichten
         )
       (progn
         (sd-call-cmds
           (teile-umfaerben)
           :failure (sd-display-error (format nil "~a ~%=> Bei Umfaerben der Behaelterteile !" (sd-inq-error-obj :message)))
         )
       )
       (progn
         (sd-execute-annotator-command :cmd "REDRAW")
       )
     )
  )
)